Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 698950 (gtkglext-removal) - [Tracker] x11-libs/gtkglext removal (Gtk+ 2.0 extension)
Summary: [Tracker] x11-libs/gtkglext removal (Gtk+ 2.0 extension)
Status: IN_PROGRESS
Alias: gtkglext-removal
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal with 1 vote (vote)
Assignee: Gentoo Linux Gnome Desktop Team
URL: https://qa-reports.gentoo.org/output/...
Whiteboard:
Keywords: PullRequest, Tracker
Depends on: 705154 656722 698960 698962 699906 703674 705140 705528 705906 706526 710156 729504
Blocks:
  Show dependency tree
 
Reported: 2019-10-30 20:21 UTC by David Heidelberg (okias)
Modified: 2020-09-27 17:53 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description David Heidelberg (okias) 2019-10-30 20:21:12 UTC
Extremely old and unmaintained code (more than 7 years).

Since gtkglext has been depending on pangox (not maintained more than 7 years) which latest pango (1.44.x) breaking.

Pangox repository declares that:
"If you are still using
pangox, well, really, get a life..."

Also gtlglext developer responded to my email with words:
" I was generally of the impression that GtkGLExt had been superseded by functionality present in modern GTK. "


This is meta tracker for apps in main tree already depends on it.

Reproducible: Always

Steps to Reproduce:
1. application/library requires gtkglext
2. try look for new version of application, which has no longer that dependency
3. bump application
Actual Results:  
blocking update to x11-libs/pango-1.44.x for modern applications

Expected Results:  
at the end, removal of x11-libs/gtkglext from gx86
Comment 1 David Heidelberg (okias) 2019-10-30 20:22:05 UTC
Application depending on x11-libs/gtkglext at this moment:

app-emulation/vice-3.1:gtk
app-i18n/ibus-handwrite-2.1.4-r1
app-i18n/ibus-handwrite-3.0.0
app-office/upwork-5.2.3.771
dev-cpp/gtkglextmm-1.2.0-r2
dev-games/openscenegraph-3.5.5:examples+gtk
dev-games/openscenegraph-3.6.3:examples+gtk
dev-python/pygtkglext-1.1.0-r1
dev-scheme/gauche-gtk-0.6_pre1:opengl
games-board/gnubg-1.05.000-r1:opengl
games-emulation/desmume-0.9.11-r1
games-emulation/yabause-0.9.15:!qt5
games-strategy/gwp-0.4.0-r3:opengl
games-strategy/ufoai-2.5.0_p20180603:editor
media-libs/opencv-2.4.13-r3:gtk+opengl
media-libs/opencv-3.4.1-r5:gtk+opengl
media-libs/opencv-3.4.1-r6:gtk+opengl
media-sound/glmix-0.3
media-sound/snd-17.4:gtk+opengl
net-misc/anydesk-4.0.1-r1
net-misc/anydesk-5.0.0
net-misc/anydesk-5.1.2
sci-astronomy/celestia-1.6.1-r1:gnome
sci-astronomy/celestia-1.6.1-r1:gtk+!gnome
sci-astronomy/celestia-9999:gtk
sci-chemistry/gabedit-2.4.6
sci-chemistry/gabedit-2.4.7
sci-chemistry/gabedit-2.4.8
sci-chemistry/ghemical-3.0.0
sci-electronics/pcb-0_p20140316:gtk
sci-electronics/pcb-4.0.2:gtk
sci-physics/lightspeed-1.2a-r3
sci-visualization/gfsview-20120706-r1
sci-visualization/gwyddion-2.44:opengl
sci-visualization/gwyddion-2.47:opengl
Comment 2 DrSlony 2020-01-16 00:34:15 UTC
app-emulation/vice-3.4 allegedly does not depend on gtkglext, ref: https://sourceforge.net/p/vice-emu/bugs/1181/
Comment 3 Andreas Sturmlechner gentoo-dev 2020-01-16 16:32:00 UTC
(In reply to DrSlony from comment #2)
> app-emulation/vice-3.4 allegedly does not depend on gtkglext, ref:
> https://sourceforge.net/p/vice-emu/bugs/1181/
This bug already depends on the according version bump request.

No talking in trackers as usual, please.
Comment 4 Thomas Groman 2020-01-29 23:27:39 UTC
There is nothing wrong with it. I use this myself. Please do not remove this. If there is an actual bug with this library lets discuss that and perhaps it's something I can patch.
Comment 5 Thomas Groman 2020-01-29 23:43:35 UTC
(In reply to David Heidelberg (okias) from comment #0)
> Extremely old and unmaintained code (more than 7 years).

It still compiles and does the same thing it did 7 years ago.

> Since gtkglext has been depending on pangox (not maintained more than 7
> years) which latest pango (1.44.x) breaking.

Can you elaborate? point to a bug number?

> Pangox repository declares that:
> "If you are still using
> pangox, well, really, get a life..."

talking to people like this really does not help anything. I get that if the developer doesn't want to care about this anymore that's fine, but perhaps whatever issue we are having can be solved by a simple patch, or a fork. old projects like this are generally 'mature' or otherwise considered finished and only require small api changes for when other newer underlying libs come along or gets ported to a new major kernel version (which is not really a thing on Linux as Linux retains ABI very good).

> Also gtlglext developer responded to my email with words:
> " I was generally of the impression that GtkGLExt had been superseded by
> functionality present in modern GTK. "

The GNOME toolkit (gtk3) does not replace the Gimp toolkit for many needs. Especially as a generic *nix graphics toolkit. There are many issues that still need to be worked out with it and it's slower and more memory consuming that gtk2 for zero additional functionality when doing a direct port. It's theming engine is also still broken, leading to campaigns like this: https://linuxreviews.org/GNOME_Developers_have_Made_Their_Moves_against_Themes
Comment 6 David Heidelberg (okias) 2020-01-30 12:45:28 UTC
(In reply to Thomas Groman from comment #5)
> (In reply to David Heidelberg (okias) from comment #0)
> > Extremely old and unmaintained code (more than 7 years).
> 
> It still compiles and does the same thing it did 7 years ago.


Yup, with right tools Linux 0.0.1 also compiles, but there is reason why people don't use it today.

> 
> > Since gtkglext has been depending on pangox (not maintained more than 7
> > years) which latest pango (1.44.x) breaking.
> 
> Can you elaborate? point to a bug number?

Please Google it.
> 
> > Pangox repository declares that:
> > "If you are still using
> > pangox, well, really, get a life..."
> 
> talking to people like this really does not help anything. I get that if the
> developer doesn't want to care about this anymore that's fine, but perhaps
> whatever issue we are having can be solved by a simple patch, or a fork. old
> projects like this are generally 'mature' or otherwise considered finished
> and only require small api changes for when other newer underlying libs come
> along or gets ported to a new major kernel version (which is not really a
> thing on Linux as Linux retains ABI very good).
> 

I agree, but since software is unsupported by their original developers, it's unlikely it will work correctly, due fact that Linux ecosystem is still developing, so it's not stuck at some point.

> > Also gtlglext developer responded to my email with words:
> > " I was generally of the impression that GtkGLExt had been superseded by
> > functionality present in modern GTK. "
> 
> The GNOME toolkit (gtk3) does not replace the Gimp toolkit for many needs.
> Especially as a generic *nix graphics toolkit.

https://gitlab.gnome.org/GNOME/gimp/ yes, generally it does. it's true it took GTK3 really long to mature.

> There are many issues that
> still need to be worked out with it and it's slower and more memory
> consuming that gtk2 for zero additional functionality when doing a direct

You don't want use GTK2 these days, unless you run some ancient machine or/and old software...

> port. It's theming engine is also still broken, leading to campaigns like
> this:
> https://linuxreviews.org/
> GNOME_Developers_have_Made_Their_Moves_against_Themes

And also, GTK2 looks like s*it. And this campaigns more target distributions, which changes look & feel (also icons etc.) and then people goes complain to application authors instead of distributions...

Also most of people grown up from theming desktop/mobile with cool themes instead of using just light/dark/black options... It's nice to have possibility thou, which GTK3 doesn't prevent.
Comment 7 Andreas Sturmlechner gentoo-dev 2020-01-30 17:55:56 UTC
gtkglext *will* be removed, the question is not if, but when.

No talking in tracker bugs please.
Comment 8 Thomas Groman 2020-02-01 00:21:47 UTC
> Please Google it.

Oh, of course. thank you so much for your help. 

> 
> I agree, but since software is unsupported by their original developers,
> it's unlikely it will work correctly,

Ok, please clarify. This part is important. Are you saying software will get removed from the tree not because there's an issue, but because upstream says it's EOL? Not that there are no downstream maintainers, but simply because of an upstream decision?

But as long as there is an upstream maintaining the software it's fine in the tree?

> it's true it
> took GTK3 really long to mature.

GTK3 has still not reached maturity and you see this with glitchy scrollbars, conflicting styles, and extremely difficult to use filepicker.

> > There are many issues that
> > still need to be worked out with it and it's slower and more memory
> > consuming that gtk2 for zero additional functionality when doing a direct
> 
> You don't want use GTK2 these days, unless you run some ancient machine
> or/and old software...

Simply not true, and immediately disprovable with a few screenshots and code examples.

> > port. It's theming engine is also still broken, leading to campaigns like
> > this:
> > https://linuxreviews.org/
> > GNOME_Developers_have_Made_Their_Moves_against_Themes
> 
> And also, GTK2 looks like s*it. 
That's an opinion and a relative one at that. Not a fact. I've got a lot of opinions about GNOME3 and post RHEL6 RedHat software but this is not the place for it.
Comment 9 Thomas Groman 2020-02-20 08:37:27 UTC
Please do not remove lightspeed. It works absolutely fine.
Comment 10 Andreas Sturmlechner gentoo-dev 2020-08-30 09:49:53 UTC
leio, please checkout PR and ack.
Comment 11 Andreas Sturmlechner gentoo-dev 2020-09-24 11:54:02 UTC
ping...
Comment 12 Larry the Git Cow gentoo-dev 2020-09-27 17:52:07 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=d4572d0ed3af333fdfd9daae7d3fbfa9a8c24bf1

commit d4572d0ed3af333fdfd9daae7d3fbfa9a8c24bf1
Author:     Andreas Sturmlechner <asturm@gentoo.org>
AuthorDate: 2020-08-22 15:08:37 +0000
Commit:     Andreas Sturmlechner <asturm@gentoo.org>
CommitDate: 2020-09-27 17:51:39 +0000

    x11-libs/gtkglext: Drop 1.2.0-r4 and package to unstable
    
    With ~arch net-misc/anydesk as the only revdep there is no need to put
    now even more modified version 1.2.0-r5 to stable.
    
    Bug: https://bugs.gentoo.org/698950
    Package-Manager: Portage-3.0.4, Repoman-3.0.1
    Signed-off-by: Andreas Sturmlechner <asturm@gentoo.org>

 x11-libs/gtkglext/gtkglext-1.2.0-r4.ebuild | 59 ------------------------------
 1 file changed, 59 deletions(-)

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=84993a1f3cb3db508333620a7af68da09510bdfd

commit 84993a1f3cb3db508333620a7af68da09510bdfd
Author:     Andreas Sturmlechner <asturm@gentoo.org>
AuthorDate: 2020-08-22 15:04:38 +0000
Commit:     Andreas Sturmlechner <asturm@gentoo.org>
CommitDate: 2020-09-27 17:51:38 +0000

    x11-libs/gtkglext: Drop x11-libs/pangox-compat dependency
    
    Bug: https://bugs.gentoo.org/698950
    Bug: https://bugs.gentoo.org/706344
    Package-Manager: Portage-3.0.4, Repoman-3.0.1
    Signed-off-by: Andreas Sturmlechner <asturm@gentoo.org>

 .../gtkglext/files/gtkglext-1.2.0-no-pangox.patch  | 184 +++++++++++++++++++++
 x11-libs/gtkglext/gtkglext-1.2.0-r5.ebuild         |  62 +++++++
 2 files changed, 246 insertions(+)
Comment 13 Andreas Sturmlechner gentoo-dev 2020-09-27 17:53:51 UTC
No longer blocking bug 698922.